
/**
 * Main function, check quote and add event
 */
Drupal.behaviors.deliverytimeslot = function () {
  // start settings
  if (Drupal.settings.deliverytimeslot.no_hide != 1) {
    $("#deliverytimeslot-pane").hide();
  }
  var pattern = Drupal.settings.deliverytimeslot.reg;
  // only go if we have delivery table set
  if (pattern) {
    // case one value: only one shipping quote, no input radios
    var onevalue = $("#quote").find("input:hidden[name=quote-option]").val();
    if (window.set_line_item && onevalue) {
      var reg = new RegExp(eval('"(' + pattern + ')"'), "g");
      if (reg.test(onevalue)){
        $("#deliverytimeslot-pane").fadeIn("slow");
        timeslotCallback(onevalue);
      } else {
        $("#deliverytimeslot-pane").fadeOut("slow");
        $('#timeslot').empty();
      }
    } else {
      // case multiple quotes: bind input radios
      $('#quote input:radio:not(.deliverytimeslot-processed)').addClass('deliverytimeslot-processed').each(function(){
        $(this).bind('click', function(){requestTimeslot($(this).val())});
      });
    }
  }

};

/**
 * Check if quote get time slots
 */
function requestTimeslot(quote) {
  var reg = new RegExp(eval('"(' + Drupal.settings.deliverytimeslot.reg + ')"'), "g");
  if (quote && reg.test(quote)){
    $("#deliverytimeslot-pane").fadeIn("slow");
    timeslotCallback(quote);
  } else {
    $("#deliverytimeslot-pane").fadeOut("slow");
    $('#timeslot').empty();
  }
}

/**
 * Callback to display time slots table
 */
function timeslotCallback(quote) {

  var updateCallback = function (progress, status, pb) {
    if (progress == 100) {
      pb.stopMonitoring();
    }
  };
  var progress = new Drupal.progressBar('uc_deliverytimeslot');
  progress.setProgress(-1, Drupal.settings.deliverytimeslot.progress_msg);
  $("#timeslot").empty().append(progress.element);

  $.post(Drupal.settings.ucURL.deliveryTimeslot, {quote: quote},
    function(contents) {
      if (contents) {
        $('#timeslot').empty().append(contents);
      } else {
        $("#deliverytimeslot-pane").fadeOut("slow");
        $('#timeslot').empty();
      }
    }
  );
  return false;
}
