<?php

/**
 * @file
 * Menu callbacks for shipping quotes requested through AJAX.
 */

/**
 * Callback to return the time slots table of the appropriate quoting method(s).
 */
function uc_deliverytimeslot_request() {
  if (isset($_POST['quote'])) {
    $quote = explode('---', check_plain($_POST['quote']));
    $quote = $quote[0];
    print uc_deliverytimeslot_display($quote);
    exit();
  }
  else {
    return FALSE;
  }
}

/**
 * Create and display the deliverytimeslot form in a table.
 *
 */
function uc_deliverytimeslot_display($quote) {
  $set_day = $set_sid = FALSE;
  $delta = variable_get('uc_deliverytimeslot_display_days_future', 0);
  if ($delta == 0) {
    $offset = variable_get('uc_deliverytimeslot_display_hours_future', 2) * 3600;
  }
  else {
    $offset = 0;
  }
  $disp = variable_get('uc_deliverytimeslot_display_days', 5) + $delta;
  $disp_mode = variable_get('uc_deliverytimeslot_display_mode', 'day');
  $week_days = variable_get('uc_deliverytimeslot_week_days', _uc_deliverytimeslot_week_days());

  // back and error on checkout form
  if (isset($_SESSION['deliverytimeslot'])) {
    $tmp_value = explode('|', $_SESSION['deliverytimeslot']);
    $set_day = (int)$tmp_value[0];
    $set_sid = (int)$tmp_value[1];
  }

  // rows construction day on header
  $i = 0;
  if ($disp_mode == 'day') {
    $table_class = 'horizontal';
    $timeslot = _uc_deliverytimeslot_timeslot();
    foreach ($timeslot AS $sid => $slot) {
      $i < count($timeslot) ? $i++ : $i = 0;
      $row = $header = array();
      $row[] = array('data' => $slot['title'], 'class' => 'deliverytimeslot headcol', 'header' => TRUE);

      for ($delt = $delta; $delt < $disp; $delt++) {
        $timestamps = _uc_deliverytimeslot_date(FALSE, $delt);
        $day = strtolower(date('l', $timestamps));
        if (isset($week_days[$day])) {
          $header[] = array('data' => format_date($timestamps, 'custom', variable_get('uc_deliverytimeslot_display_format', 'l F j')), 'class' => 'deliverydate');
          // back button
          if (($set_day && $set_day == $timestamps) && ($set_sid == (int)$sid)) {
            $checked = ' checked="checked"';
          }
          else {
            $checked = '';
          }
          $max = $data = '';

          $sp_query = db_query("SELECT max_limit FROM {uc_deliverytimeslot_special} WHERE quote = '%s' AND date = %d AND sid = %d", $quote, $timestamps, $sid);
          $sp_det = db_fetch_array($sp_query);
          $booked_num = db_result(db_query("SELECT Count(*) as num FROM {uc_deliverytimeslot_order} WHERE date = %d AND sid = %d AND confirmed = 1", $timestamps, $sid));

          if ($sp_det != 0) {
            $max = $sp_det['max_limit'];
          }
          else {
            $default_det = db_fetch_array(db_query("SELECT max_limit FROM {uc_deliverytimeslot_default} WHERE quote = '%s' AND day = '%s' AND sid = %d", $quote, $day, $sid));
            $max = $default_det['max_limit'];
          }

          $start = $slot['start_h'] . sprintf('%02d', $slot['start_m']);
          // not full and not before current time if start today
          if ((!$max || $max == 0) || ($delta == 0 && $delt == 0 && ($start < format_date(time() + $offset, 'custom', 'Hi')))) {
            $class = 'na';
          }
          elseif (($booked_num >= $max) && $checked == '') {
            $class = 'full';
          }
          else {
            $data = '<input type="radio" class="form-radio" value="'. $timestamps .'|'. $sid .'" name="delivery_timeslot" id="edit-delivery-timeslot-'. $timestamps .'-'. $sid .'" '. $checked .'/>';
            $class = 'free';
          }
          $row[] = array('data' => $data, 'class' => $class);
        }
        else {
          $i == 1 ? $disp++ : '' ;
        }

      }
    $rows[] = $row;
    $headers = array_merge(array(array('data' => '', 'class' => 'headcol empty')), $header);
    }
  }
  // rows construction day on left column
  else {
    $table_class = 'vertical';
    $timeslot = _uc_deliverytimeslot_timeslot();
    $headers = array_merge(array(array('data' => '', 'class' => 'headcol empty')), _uc_deliverytimeslot_timeslot(NULL, TRUE));
    for ($delt = $delta; $delt < $disp; $delt++) {
      $timestamps = _uc_deliverytimeslot_date(FALSE, $delt);
      $day = strtolower(date('l', $timestamps));
      $row = array();

      if (isset($week_days[$day])) {

        $row[] = array('data' => format_date($timestamps, 'custom', variable_get('uc_deliverytimeslot_display_format', 'l F j')), 'class' => 'headcol', 'header' => TRUE);

        foreach ($timeslot as $sid => $slot) {
          // back button
          if (($set_day && $set_day == $timestamps) && ($set_sid == $sid)) {
            $checked = ' checked="checked"';
          }
          else {
            $checked = '';
          }
          $class = 'free';
          $max = $data = '';
          $sp_query = db_query("SELECT * FROM {uc_deliverytimeslot_special} WHERE quote = '%s' AND date = %d AND sid = %d", $quote, $timestamps, $sid);
          $sp_det = db_fetch_array($sp_query);
          $booked_num = db_result(db_query("SELECT Count(*) as num FROM {uc_deliverytimeslot_order} WHERE date = %d AND sid = %d AND confirmed = 1", $timestamps, $sid));

          if ($sp_det != 0) {
            $max = $sp_det['max_limit'];
          }
          else {
            $default_det = db_fetch_array(db_query("SELECT * FROM {uc_deliverytimeslot_default} WHERE quote = '%s' AND day = '%s' AND sid = %d", $quote, $day, $sid));
            $max = $default_det['max_limit'];
          }
          $start = $slot['start_h'] . sprintf('%02d', $slot['start_m']);
          // not full and not before current time if start today
          if ((!$max || $max == 0) || ($delta == 0 && $delt == 0 && ($start < format_date(time() + $offset, 'custom', 'Hi')))) {
            $class = 'na';
          }
          elseif (($booked_num >= $max) && $checked == '') {
            $class = 'full';
          }
          else {
            $data = '<input type="radio" class="form-radio" value="'. $timestamps .'|'. $sid .'" name="delivery_timeslot" id="edit-delivery-timeslot-'. $timestamps .'-'. $sid .'" '. $checked .'/>';
          }
          $row[] = array('data' => $data, 'class' => $class);
        }
      }
      else {
        $disp++;
      }
    $rows[] = $row;
    }
  }
  // main delivery table
  $main_table = theme('table', $headers, $rows, array('class' => 'delivery '. $table_class, 'id' => 'deliverytimeslot'));
  $output = '<div id="timeslot-'. $table_class .'">'. $main_table .'</div>';

  // legend table
  if (variable_get('uc_deliverytimeslot_display_legend', 0) == 1) {
    $row_legend[] = array('data' => t("n/a"), 'class' => 'na');
    $row_legend[] = array('data' => t("full"), 'class' => 'full');
    $row_legend[] = array('data' => t("free"), 'class' => 'free');
    $rows_legend[] = $row_legend;
    $headers_legend[] = array('data' => t("legend"), 'colspan' => 3);
    $legend = '<br class="clear"/><div id="timeslot-legend">'. theme('table', $headers_legend, $rows_legend, array('class' => 'delivery')) .'</div>';
    $output .= $legend;
  }

  return $output;
}
